// ===================================================================
// $Id: lrcache.h,v 1.2 2005/11/02 12:58:44 xkrivanj Exp $
//
// lrcache.h
//  Header file for the CLastIRCacheResult class.
//  Class used as a cache for the last result of the query
//   to the (ir)radiance cache.
//
// Class: CLastIRCacheResult
//
// Initial coding by Jaroslav Krivanek, May 2004.

#ifndef __LRCACHE_H__
#define __LRCACHE_H__

// GOLEM headers
#include "configh.h"
#include "vector3.h"
#include "color.h"

__BEGIN_GOLEM_HEADER

class CSurface;

/// Cached result of the last quuery to the (ir)radiance cache.
/**
  This class stores all information relevat to the query to the
  (ir)radiance cache. Result stored here might be under certain 
  cirtumstances used for subsequent queries wtihtou having to 
  search the cache again.
 */
class CLastIRCacheResult {
public:
    unsigned long  nCachedSamples;
    unsigned long  nFailed;
    unsigned long  nSucceed;

		const CSurface *surface;
    CVector3D normal;
    CVector3D point;
    CVector3D grad[3];
    float    minR;

    /// @@@ prejmenovat podle skutecnosti
    float     maxCacheCriterion;

    CValues result;
    CLastIRCacheResult();
};

__END_GOLEM_HEADER

#endif // __LRCACHE_H__


