// ===================================================================
// $Id: point2.h,v 1.2 2005/11/29 16:04:04 xkrivanj Exp $
//  
//  point2.h
//    Simple 2d point structure
//   
// REPLACEMENT_STRING
//
// Initial coding by Jaroslav Krivanek (April, 2005).

#ifndef __POINT2_H__
#define __POINT2_H__

// GOLEM headers
#include "configh.h"

// standard headers

__BEGIN_GOLEM_HEADER

template<class T>
class CPoint2 {
public:
  union {
    T v[2];
    struct {T x,y;};
  };

  inline CPoint2() {}
  inline CPoint2(const T& xx, const T& yy)
    : x(xx), y(yy) 
  {}

  inline void Set(const T& xx, const T& yy) {x=xx; y=yy;}
};

// --------------------------------------------------------------------------
//   operator<<
// --------------------------------------------------------------------------
template<class T>
inline ostream&
operator<< (ostream &s, const CPoint2<T> &p)
{
  return s << "(" << p.x << ", " << p.y << ")";
}


__END_GOLEM_HEADER

#endif // __POINT2_H__
