// ===================================================================
// $Id: rect.h,v 1.2 2005/11/29 16:04:05 xkrivanj Exp $
//  
//  rect.h
//    Simple rectangle structure
//   
// REPLACEMENT_STRING
//
// Initial coding by Jaroslav Krivanek (March, 2005).

#ifndef __RECT_H__
#define __RECT_H__

// GOLEM headers
#include "configh.h"

// standard headers

__BEGIN_GOLEM_HEADER

template<class T>
class CRect {
public:
  union {
    T v[4];
    struct {
      union {
        struct { T xmin,ymin; };
        T bottomleft[2];
      };
      union {
        struct { T xmax,ymax; };
        T topright[2];
      };
    };
  };

  inline CRect() {}
  inline CRect(const T& xxmin, const T& yymin, const T& xxmax, const T& yymax)
    : xmin(xxmin), ymin(yymin), xmax(xxmax), ymax(yymax)
  {}

  /// Returns true is a point is inside the rectangle. Windows API terminology.
  inline bool PtInRect(const T &x,const T &y) const
  { return x>=xmin && x<=xmax && y>=ymin && y<=ymax; }

  /// Returns true is a point is inside the rectangle.
  inline bool Contains(const T &x,const T &y) const { return PtInRect(x,y); }
};

__END_GOLEM_HEADER

#endif // __RECT_H__
